flexiapi/routes/web.php
<?php
/*
    Flexisip Account Manager is a set of tools to manage SIP accounts.
    Copyright (C) 2020 Belledonne Communications SARL, All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

use App\Http\Controllers\Account\AccountController;
use App\Http\Controllers\Account\ApiKeyController;
use App\Http\Controllers\Account\CreationRequestTokenController;
use App\Http\Controllers\Account\DeviceController;
use App\Http\Controllers\Account\EmailController;
use App\Http\Controllers\Account\PasswordController;
use App\Http\Controllers\Account\PhoneController;
use App\Http\Controllers\Account\ProvisioningController;
use App\Http\Controllers\Account\RecoveryController;
use App\Http\Controllers\Admin\AccountAccountTypeController;
use App\Http\Controllers\Admin\AccountActionController;
use App\Http\Controllers\Admin\AccountActivityController;
use App\Http\Controllers\Admin\AccountContactController;
use App\Http\Controllers\Admin\AccountDeviceController;
use App\Http\Controllers\Admin\AccountDictionaryController;
use App\Http\Controllers\Admin\AccountImportController;
use App\Http\Controllers\Admin\AccountTypeController;
use App\Http\Controllers\Admin\AccountController as AdminAccountController;
use App\Http\Controllers\Admin\AccountStatisticsController;
use App\Http\Controllers\Admin\ContactsListController;
use App\Http\Controllers\Admin\ContactsListContactController;
use App\Http\Controllers\Admin\PhoneCountryController;
use App\Http\Controllers\Admin\ResetPasswordEmailController;
use App\Http\Controllers\Admin\SpaceController;
use App\Http\Controllers\Admin\StatisticsController;
use Illuminate\Support\Facades\Route;

Route::redirect('/', 'login')->name('account.home');
Route::get('documentation', 'Account\AccountController@documentation')->name('account.documentation');
Route::get('about', 'AboutController@about')->name('about');

Route::middleware(['web_panel_enabled', 'space.expired'])->group(function () {
    Route::get('login', 'Account\AuthenticateController@login')->name('account.login');
    Route::post('authenticate', 'Account\AuthenticateController@authenticate')->name('account.authenticate');
    Route::get('authenticate/qrcode/{token?}', 'Account\AuthenticateController@loginAuthToken')->name('account.authenticate.auth_token');
    Route::get('logout', 'Account\AuthenticateController@logout')->name('account.logout');

    Route::get('reset_password/{token}', 'Account\ResetPasswordEmailController@change')->name('account.reset_password_email.change');
    Route::post('reset_password', 'Account\ResetPasswordEmailController@reset')->name('account.reset_password_email.reset');

    // Deprecated
    Route::get('authenticate/email/{code}', 'Account\AuthenticateController@validateEmail')->name('account.authenticate.email_confirm');

    Route::prefix('creation_token')->controller(CreationRequestTokenController::class)->group(function () {
        Route::get('check/{token}', 'check')->name('account.creation_request_token.check');
        Route::post('validate', 'validateToken')->name('account.creation_request_token.validate');
    });
});

Route::group(['middleware' => ['auth.jwt', 'auth.digest_or_key']], function () {
    Route::get('provisioning/me', 'Account\ProvisioningController@me')->name('provisioning.me');

    // vCard 4.0
    Route::get('contacts/vcard/{sip}', 'Account\ContactVcardController@show')->name('account.contacts.vcard.show');
    Route::get('contacts/vcard', 'Account\ContactVcardController@index')->name('account.contacts.vcard.index');

    // vCards Storage
    Route::get('vcards-storage/{uuid}', 'Account\VcardsStorageController@show')->name('account.vcards-storage.show');
    Route::get('vcards-storage/', 'Account\VcardsStorageController@index')->name('account.vcards-storage.index');
});

Route::name('provisioning.')->prefix('provisioning')->controller(ProvisioningController::class)->group(function () {
    Route::get('documentation', 'documentation')->name('documentation');
    Route::get('auth_token/{auth_token}', 'authToken')->name('auth_token');
    Route::get('qrcode/{provisioning_token}', 'qrcode')->name('qrcode');
    Route::get('{provisioning_token}', 'provision')->name('provision');
    Route::get('/', 'show')->name('show');
});

Route::middleware(['web_panel_enabled', 'space.expired'])->group(function () {
    Route::middleware(['public_registration'])->group(function () {
        Route::redirect('register', 'register/email')->name('account.register');

        Route::middleware(['phone_registration'])->group(function () {
            Route::get('register/phone', 'Account\RegisterController@registerPhone')->name('account.register.phone');
        });

        Route::get('register/email', 'Account\RegisterController@registerEmail')->name('account.register.email');
        Route::post('accounts', 'Account\AccountController@store')->name('account.store');
    });

    Route::prefix('recovery')->controller(RecoveryController::class)->group(function () {
        Route::get('phone', 'showPhone')->name('account.recovery.show.phone');
        Route::get('email', 'showEmail')->name('account.recovery.show.email');
        Route::post('/', 'send')->name('account.recovery.send');
        Route::post('confirm', 'confirm')->name('account.recovery.confirm');
    });

    Route::name('account.')->middleware(['auth', 'auth.check_blocked'])->group(function () {
        Route::get('blocked', 'Account\AccountController@blocked')->name('blocked');

        Route::prefix('email')->controller(EmailController::class)->group(function () {
            Route::get('change', 'change')->name('email.change');
            Route::post('change', 'requestChange')->name('email.request_change');
            Route::get('validate', 'validateChange')->name('email.validate');
            Route::post('/', 'store')->name('email.update');
        });

        Route::middleware(['phone_registration'])->group(function () {
            Route::prefix('phone')->controller(PhoneController::class)->group(function () {
                Route::get('change', 'change')->name('phone.change');
                Route::post('change', 'requestChange')->name('phone.request_change');
                Route::get('validate', 'validateChange')->name('phone.validate');
                Route::post('/', 'store')->name('phone.update');
            });
        });

        Route::name('device.')->prefix('devices')->controller(DeviceController::class)->group(function () {
            Route::get('/', 'index')->name('index');
            Route::get('{device_id}/delete', 'delete')->name('delete');
            Route::delete('/', 'destroy')->name('destroy');
        });

        Route::controller(AccountController::class)->group(function () {
            Route::get('dashboard', 'dashboard')->name('dashboard');

            Route::get('delete', 'delete')->name('delete');
            Route::delete('delete', 'destroy')->name('destroy');
        });

        Route::prefix('password')->controller(PasswordController::class)->group(function () {
            Route::get('/', 'show')->name('password.show');
            Route::post('/', 'update')->name('password.update');
        });

        Route::prefix('api_key')->controller(ApiKeyController::class)->group(function () {
            Route::get('/', 'show')->name('api_key.show');
            Route::post('/', 'update')->name('api_key.update');
        });

        Route::post('auth_tokens', 'Account\AuthTokenController@create')->name('auth_tokens.create');
        Route::get('auth_tokens/auth/external/{token}', 'Account\AuthTokenController@authExternal')->name('auth_tokens.auth.external');
    });

    Route::get('auth_tokens/qrcode/{token}', 'Account\AuthTokenController@qrcode')->name('auth_tokens.qrcode');
    Route::get('auth_tokens/auth/{token}', 'Account\AuthTokenController@auth')->name('auth_tokens.auth');

    Route::name('admin.')->prefix('admin')->middleware(['auth.admin', 'auth.check_blocked'])->group(function () {
        Route::get('space', 'Admin\SpaceController@me')->name('spaces.me');
        Route::get('spaces/{space}/configuration', 'Admin\SpaceController@configuration')->name('spaces.configuration');
        Route::put('spaces/{space}/configuration', 'Admin\SpaceController@configurationUpdate')->name('spaces.configuration.update');

        Route::middleware(['auth.super_admin'])->group(function () {
            Route::resource('spaces', SpaceController::class);
            Route::get('spaces/delete/{id}', 'Admin\SpaceController@delete')->name('spaces.delete');

            Route::get('spaces/{space}/administration', 'Admin\SpaceController@administration')->name('spaces.administration');
            Route::put('spaces/{space}/administration', 'Admin\SpaceController@administrationUpdate')->name('spaces.administration.update');

            Route::name('phone_countries.')->controller(PhoneCountryController::class)->prefix('phone_countries')->group(function () {
                Route::get('/', 'index')->name('index');
                Route::get('/activate_all', 'activateAll')->name('activate_all');
                Route::get('/deactivate_all', 'deactivateAll')->name('deactivate_all');
                Route::get('/{code}/activate', 'activate')->name('activate');
                Route::get('/{code}/deactivate', 'deactivate')->name('deactivate');
            });
        });

flexiapi/app/Http/Controllers/Admin/SpaceController.php
<?php
/*
    Flexisip Account Manager is a set of tools to manage SIP accounts.
    Copyright (C) 2023 Belledonne Communications SARL, All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;

use App\Http\Controllers\Controller;
use App\Space;
use App\Rules\Ini;
use Illuminate\Validation\Rule;

class SpaceController extends Controller
{
    public function index()
    {
        return view('admin.space.index', ['spaces' => Space::withCount('accounts')->orderBy('host')->get()]);
    }

    public function me(Request $request)
    {
        return view('admin.space.show', [
            'space' => $request->user()->space
        ]);
    }

    public function show(Space $space)
    {
        return view('admin.space.show', [
            'space' => $space
        ]);
    }

    public function create()
    {
        return view('admin.space.create', [
            'space' => new Space()
        ]);
    }

    public function store(Request $request)
    {
        $fullHost = empty($request->get('host'))
            ? config('app.root_host')
            : $request->get('host') . '.' . config('app.root_host');

        $request->merge(['full_host' => $fullHost]);
        $request->validate([
            'name' => 'required|unique:spaces',
            'domain' => 'required|unique:spaces|regex:/'. Space::DOMAIN_REGEX . '/',
            'host' => 'nullable|regex:/'. Space::HOST_REGEX . '/',
            'full_host' => 'required|unique:spaces,host',
        ]);

        $space = new Space();
        $space->name = $request->get('name');
        $space->domain = $request->get('domain');
        $space->host = $request->get('full_host');
        $space->save();

        return redirect()->route('admin.spaces.index');
    }

    public function edit(Space $space)
    {
        return view('admin.space.edit', [
            'space' => $space
        ]);
    }

    public function update(Request $request, Space $space)
    {
        $request->validate([
            'max_account' => 'required|integer',
        ]);

        $space = $this->setAppConfiguration($request, $space);
        $space->save();

        return redirect()->back();
    }

    public function configuration(Space $space)
    {
        return view('admin.space.configuration', [
            'space' => $space
        ]);
    }

    public function configurationUpdate(Request $request, Space $space)
    {
        $space = $this->setConfiguration($request, $space);
        $space->save();

        return redirect()->route('admin.spaces.configuration', $space);
    }

    public function administration(Space $space)
    {
        return view('admin.space.administration', [
            'space' => $space
        ]);
    }

    public function administrationUpdate(Request $request, Space $space)
    {
        $request->validate([
            'name' => ['required', Rule::unique('spaces')->ignore($space->id)],
            'max_accounts' => 'required|integer|min:0',
            'expire_at' => 'nullable|date|after_or_equal:today'
        ]);

        if ($request->get('max_accounts') > 0) {
            $request->validate([
                'max_accounts' => 'integer|min:' . $space->accounts()->count()
            ]);
        }

        $space->name = $request->get('name');
        $space->super = getRequestBoolean($request, 'super');
        $space->max_accounts = $request->get('max_accounts');
        $space->expire_at = $request->get('expire_at');
        $space->custom_theme = getRequestBoolean($request, 'custom_theme');
        $space->web_panel = getRequestBoolean($request, 'web_panel');
        $space->save();

        return redirect()->route('admin.spaces.show', $space);
    }

    private function setConfiguration(Request $request, Space $space)
    {
        $request->validate([
            'newsletter_registration_address' => 'nullable|email',
            'custom_provisioning_entries' => ['nullable', new Ini]
        ]);

        $space->copyright_text = $request->get('copyright_text');
        $space->intro_registration_text = $request->get('intro_registration_text');
        $space->confirmed_registration_text = $request->get('confirmed_registration_text');
        $space->newsletter_registration_address = $request->get('newsletter_registration_address');
        $space->account_proxy_registrar_address = $request->get('account_proxy_registrar_address');
        $space->account_realm = $request->get('account_realm');
        $space->custom_provisioning_entries = $request->get('custom_provisioning_entries');
        $space->custom_provisioning_overwrite_all = getRequestBoolean($request, 'custom_provisioning_overwrite_all');
        $space->provisioning_use_linphone_provisioning_header = getRequestBoolean($request, 'provisioning_use_linphone_provisioning_header');

        $space->public_registration = getRequestBoolean($request, 'public_registration');
        $space->phone_registration = getRequestBoolean($request, 'phone_registration');
        $space->intercom_features = getRequestBoolean($request, 'intercom_features');

        return $space;
    }

    private function setAppConfiguration(Request $request, Space $space)
    {
        $request->validate([
            'max_account' => 'required|integer',
        ]);

        $space->disable_chat_feature = getRequestBoolean($request, 'disable_chat_feature', reversed: true);
        $space->disable_meetings_feature = getRequestBoolean($request, 'disable_meetings_feature', reversed: true);
        $space->disable_broadcast_feature = getRequestBoolean($request, 'disable_broadcast_feature', reversed: true);
        $space->hide_settings = getRequestBoolean($request, 'hide_settings', reversed: true);
        $space->max_account = $request->get('max_account', 0);
        $space->hide_account_settings = getRequestBoolean($request, 'hide_account_settings', reversed: true);
        $space->disable_call_recordings_feature = getRequestBoolean($request, 'disable_call_recordings_feature', reversed: true);
        $space->only_display_sip_uri_username = getRequestBoolean($request, 'only_display_sip_uri_username');
        $space->assistant_hide_create_account = getRequestBoolean($request, 'assistant_hide_create_account', reversed: true);
        $space->assistant_disable_qr_code = getRequestBoolean($request, 'assistant_disable_qr_code', reversed: true);
        $space->assistant_hide_third_party_account = getRequestBoolean($request, 'assistant_hide_third_party_account', reversed: true);

        return $space;
    }

    public function delete(Request $request, int $id)
    {
        $space = Space::findOrFail($id);
        return view('admin.space.delete', [
            'space' => $space
        ]);
    }

    public function destroy(Request $request, int $id)
    {
        $space = Space::findOrFail($id);

        $request->validate([
            'domain' => [
                'required',
                Rule::in(['first-zone', $space->domain]),
            ]
        ]);

        $space->delete();

        return redirect()->route('admin.spaces.index');
    }
}

flexiapi/resources/views/admin/space/administration.blade.php
@extends('layouts.main')

@section('breadcrumb')
    <li class="breadcrumb-item">
        <a href="{{ route('admin.spaces.index') }}">{{ __('Spaces') }}</a>
    </li>
    <li class="breadcrumb-item">
        <a href="{{ route('admin.spaces.show', $space->id) }}">
            {{ $space->name }}
        </a>
    </li>
    <li class="breadcrumb-item active" aria-current="page">{{ __('Administration') }}</li>
@endsection

@section('content')
    <header>
        <h1><i class="ph">globe-hemisphere-west</i> {{ $space->name }}</h1>
    </header>

    @include('admin.space.tabs')

    <form method="POST"
        action="{{ route('admin.spaces.administration.update', $space) }}"
        accept-charset="UTF-8">
        @csrf
        @method('put')

        <div>
            <input name="name" id="name" placeholder="My Space Name" type="text" value="{{ $space->name }}">
            <label for="name">{{ __('Name') }}</label>
            @include('parts.errors', ['name' => 'name'])
        </div>

        <div>
            <input name="max_accounts" id="max_accounts" type="number" min="0" value="{{ $space->max_accounts }}">
            <label for="max_accounts">{{ __('Max accounts') }}</label>
            <span class="supporting">{{ __('Unlimited if set to 0') }}</span>
            @include('parts.errors', ['name' => 'max_accounts'])
        </div>

        <div>
            <input name="expire_at" id="expire_at" type="date" @if ($space->expire_at) value="{{ $space->expire_at->toDateString() }}" @endif min="{{ \Carbon\Carbon::now()->toDateString() }}">
            <label for="expire_at">{{ __('Expiration') }}</label>
            <span class="supporting">{{ __('Clear to never expire') }}</span>
        </div>

        <div class="large">
            @include('parts.form.toggle', ['object' => $space, 'key' => 'super', 'label' => __('Super Space'), 'supporting' => __('All the admins in will be super admins')])
        </div>

        <h3 class="large">Interface</h3>
        <div>
            @include('parts.form.toggle', ['object' => $space, 'key' => 'custom_theme', 'label' => __('Allow a custom CSS theme'), 'supporting' => __('Check the README.md documentation')])
        </div>
        <div>
            @include('parts.form.toggle', ['object' => $space, 'key' => 'web_panel', 'label' => __('Enable the web interface'), 'supporting' => __('It might actually disable this page, be careful')])
        </div>

        <div class="large">
            <input class="btn" type="submit" value="{{ __('Update') }}">
        </div>
    </form>
@endsection

flexiapi/resources/views/admin/space/configuration.blade.php
@extends('layouts.main')

@section('breadcrumb')
    @if (auth()->user()->superAdmin)
        <li class="breadcrumb-item">
            <a href="{{ route('admin.spaces.index') }}">{{ __('Spaces') }}</a>
        </li>
        <li class="breadcrumb-item">
            <a href="{{ route('admin.spaces.show', $space->id) }}">
                {{ $space->name }}
            </a>
        </li>
    @else
        <li class="breadcrumb-item">
            <a href="{{ route('admin.spaces.me') }}">
                {{ $space->name }}
            </a>
        </li>
    @endif
    <li class="breadcrumb-item active" aria-current="page">{{ __('Configuration') }}</li>
@endsection

@section('content')
    <header>
        <h1><i class="ph">globe-hemisphere-west</i> {{ $space->name }}</h1>
    </header>

    @include('admin.space.tabs')

    <form method="POST"
        action="{{ route('admin.spaces.configuration.update', $space) }}"
        accept-charset="UTF-8">
        @csrf
        @method('put')

        <div class="large">
            <textarea name="copyright_text" id="copyright_text">{{ $space->copyright_text }}</textarea>
            <label for="copyright_text">{{ __('Copyright text') }}</label>
            @include('parts.errors', ['name' => 'copyright_text'])
        </div>

        <div class="large">
            <textarea name="intro_registration_text" id="intro_registration_text">{{ $space->intro_registration_text }}</textarea>
            <label for="intro_registration_text">{{ __('Registration introduction') }}</label>
            <span class="supporting">{{ __('Markdown text') }}</span>
            @include('parts.errors', ['name' => 'intro_registration_text'])
        </div>

        <div class="large">
            <textarea name="confirmed_registration_text" id="confirmed_registration_text">{{ $space->confirmed_registration_text }}</textarea>
            <label for="confirmed_registration_text">{{ __('Confirmed registration text') }}</label>
            <span class="supporting">{{ __('Markdown text') }}</span>
            @include('parts.errors', ['name' => 'confirmed_registration_text'])
        </div>

        <div>
            <input name="newsletter_registration_address" id="newsletter_registration_address" placeholder="email@server.tld" type="email" value="{{ $space->newsletter_registration_address }}">
            <label for="newsletter_registration_address">Newsletter registration email address</label>
            <span class="supporting">An email will be sent to this address when someone register and join the newsletter</span>
            @include('parts.errors', ['name' => 'newsletter_registration_address'])
        </div>

        <div>
            <input name="account_proxy_registrar_address" id="account_proxy_registrar_address" placeholder="server.tld" value="{{ $space->account_proxy_registrar_address }}">
            <label for="account_proxy_registrar_address">Account proxy registrar address</label>
            <span class="supporting">Will be used for informational purpose in the user panel and communication emails</span>
            @include('parts.errors', ['name' => 'account_proxy_registrar_address'])
        </div>

        <h3 class="large">{{ __('Provisioning') }}</h3>

        <div class="large">
            <textarea style="min-height: 200px;" name="custom_provisioning_entries" id="custom_provisioning_entries">{{ $space->custom_provisioning_entries }}</textarea>
            <label for="custom_provisioning_entries">{{ __('Custom entries') }}</label>
            <span class="supporting">{{ __('In ini format, will complete the other settings') }}</span>
            @include('parts.errors', ['name' => 'custom_provisioning_entries'])
        </div>

        <div>
            @include('parts.form.toggle', ['object' => $space, 'key' => 'custom_provisioning_overwrite_all', 'label' => __('Allow client settings to be overwritten by the provisioning ones')])
        </div>

        <div>
            @include('parts.form.toggle', ['object' => $space, 'key' => 'provisioning_use_linphone_provisioning_header', 'label' => 'Enforce X-Linphone-Provisioning header'])
        </div>

        <h3 class="large">{{ __('Features') }}</h3>
        <div>
            @include('parts.form.toggle', ['object' => $space, 'key' => 'public_registration', 'label' => __('Public registration')])
        </div>
        <div
            @include('parts.form.toggle', ['object' => $space, 'key' => 'phone_registration', 'label' => __('Phone registration')])
        </div>
        <div>
            @include('parts.form.toggle', ['object' => $space, 'key' => 'intercom_features', 'label' => __('Intercom features')])
        </div>

        <div class="large">
            <input class="btn" type="submit" value="{{ __('Update') }}">
        </div>
    </form>
@endsection

flexiapi/resources/views/admin/space/create.blade.php
@extends('layouts.main')

@section('breadcrumb')
    <li class="breadcrumb-item">
        <a href="{{ route('admin.spaces.index') }}">{{ __('Spaces') }}</a>
    </li>
    <li class="breadcrumb-item active" aria-current="page">{{ __('Create') }}</li>
@endsection

@section('content')
    <header>
        <h1><i class="ph">user-rectangle</i> {{ __('Create') }}</h1>
        <a href="{{ route('admin.spaces.index') }}" class="btn btn-secondary oppose">{{ __('Cancel') }}</a>
    </header>

    <form method="POST"
        action="{{ route('admin.spaces.store') }}"
        accept-charset="UTF-8">
        @csrf
        @method('post')

        <div>
            <input name="name" id="name" placeholder="My Space Name" required="required" type="text" value="{{ $space->name ?? old('name') }}">
            <label for="name">{{ __('Name') }}</label>
            @include('parts.errors', ['name' => 'name'])
        </div>

        <div>
            <input placeholder="subdomain" name="host" type="text" pattern="{{ $space::HOST_REGEX}}" style="width: 60%"
                value="{{ $space->host ?? old('host') }}" onchange="copyValueTo(this, this.form.querySelector('input[name=domain]'), '.{{ config('app.root_host') }}')">
            <input placeholder=".{{ config('app.root_host') }}" style="position: absolute; width: calc(40% - 1rem); margin-left: 1rem;" disabled>
            <label for="username">{{ __('Subdomain') }}</label>
            @include('parts.errors', ['name' => 'host'])
            @include('parts.errors', ['name' => 'full_host'])
            <span class="supporting">{{ __('Cannot be changed once created.') }} {{ __('Leave empty to create a root Space.') }}</span>
        </div>

        <div class="large">
            <input placeholder="domain.sip" required="required" name="domain" type="text" pattern="{{ $space::DOMAIN_REGEX}}" value="{{ $space->domain ?? old('domain') }}">
            <label for="username">{{ __('SIP Domain') }}</label>
            @include('parts.errors', ['name' => 'domain'])
            <span class="supporting">{{ __('Cannot be changed once created.') }}</span>
        </div>

        @include('parts.form.toggle', ['object' => $space, 'key' => 'super', 'label' => __('Super space'), 'supporting' => 'All the admins in will be super admins'])

        <div class="large">
            <input class="btn" type="submit" value="{{ __('Create') }}">
        </div>

    </form>
@endsection

flexiapi/resources/views/admin/space/delete.blade.php
@extends('layouts.main')

@section('breadcrumb')
    <li class="breadcrumb-item">
        <a href="{{ route('admin.spaces.index') }}">{{ __('Spaces') }}</a>
    </li>
    <li class="breadcrumb-item active" aria-current="page">{{ __('Delete') }}</li>
@endsection

@section('content')
    <header>
        <h1><i class="ph">trash</i> {{ __('Delete') }}</h1>
        <a href="{{ route('admin.spaces.edit', $space->id) }}" class="btn btn-secondary oppose">{{ __('Cancel') }}</a>
    </header>
    <form id="delete" method="POST" action="{{ route('admin.spaces.destroy', $space) }}" accept-charset="UTF-8">
        @csrf
        @method('delete')

        <div class="large">
            <p>{{ __('You are going to permanently delete the following element. Please confirm your action.') }}</p>
            <h3>{{ $space->domain }}</h3>
            <p>This will also destroy <b>{{ $space->accounts()->count() }} related accounts</b></p>

            <input name="sip_domain" type="hidden" value="{{ $space->id }}">
        </div>

        <div>
            <input placeholder="domain.tld" required="required" name="domain" type="text">
            <label for="username">Please retype the domain here to confirm</label>
            @include('parts.errors', ['name' => 'domain'])
        </div>

        <div class="large">
            <input class="btn" type="submit" value="{{ __('Delete') }}">
        </div>
    </form>
@endsection

flexiapi/resources/views/admin/space/index.blade.php
@extends('layouts.main')

@section('breadcrumb')
    <li class="breadcrumb-item" aria-current="page">{{ __('Spaces') }}</li>
@endsection

@section('content')

<header>
    <h1><i class="ph">globe-hemisphere-west</i> {{ __('Spaces') }}</h1>
    <a class="btn oppose" href="{{ route('admin.spaces.create') }}">
        <i class="ph">plus</i>
        {{ __('Create') }}
    </a>
</header>

<table>
    <thead>
        <tr>
            <th>{{ __('Space') }}</th>
            <th>{{ __('Host') }}</th>
            <th>{{ __('SIP Domain') }}</th>
            <th>{{ __('Accounts') }}</th>
            <th>{{ __('Expiration') }}</th>
        </tr>
    </thead>
    <tbody>
        @foreach ($spaces as $space)
            <tr>
                <td>
                    <a href="{{ route('admin.spaces.show', $space->id) }}">
                        {{ $space->name }}
                        @if ($space->super) <span class="badge badge-error" title="Super domain">Super</span> @endif
                    </a>
                </td>
                <td>{{ $space->host }}</td>
                <td>{{ $space->domain }}</td>
                <td>
                    {{ $space->accounts_count }} / @if ($space->max_accounts > 0){{ $space->max_accounts }} @else <i class="ph">infinity</i>@endif
                </td>
                <td>
                    @if ($space->isExpired())
                        Expired
                    @elseif ($space->expire_at)
                        In {{ $space->daysLeft }} days
                    @else
                        <i class="ph">infinity</i>
                    @endif
                </td>
            </tr>
        @endforeach
    </tbody>
</table>

@endsection

flexiapi/resources/views/admin/space/tabs.blade.php
@php
    $items = [];

    if (auth()->user()->superAdmin) {
        $items[route('admin.spaces.show', $space->id)] = __('Information');
        $items[route('admin.spaces.administration', $space->id)] = __('Administration');
        $items[route('admin.spaces.edit', $space->id)] = __('App Configuration');
    } else if (auth()->user()->admin) {
        $items[route('admin.spaces.me')] = __('Information');
    }

    $items[route('admin.spaces.configuration', $space->id)] = __('Configuration');
@endphp

@include('parts.tabs', [
    'items' => $items
])